import javax.swing.JPanel;
import javax.swing.JOptionPane;
import java.awt.*;

/**
* @author Carlos O. Rios
* Collaboration Statement: I worked on the homework assignment alone, using only course materials.
*/

/**
* This is Homework 5 - DartboardPanel.java
* This class creates a dart for the Dartboard panel java program
* @version 1.0
*/

public class DartboardPanel extends JPanel
{

	/**
	* @param MAX_WIDTH, NUM_RINGS, RING_WIDTH sets the max width of the board to 500,
	* the number of rings (areas) to 12, and the width of each ring to 20, respectively.
	* @param numdarts  this is the number of darts, depending on how many the user puts when prompted
	* @param Dart randomdart this will set up the darts to hit the dartboard at random areas
	* @param totalscore  this sets the initial score to 0 (zero)
	*/
   private final int MAX_WIDTH = 500, NUM_RINGS = 12, RING_WIDTH = 20;
	private int numdarts;
	private Dart randomdart;
	private int totalscore=0;

	/**
	* This creates the GUI for the dartboard 
	*/
	
   public DartboardPanel ()
   {
	/**
	* This creates a string which will ask the user to type in a number
	*/
		String numdartString;
		numdartString=JOptionPane.showInputDialog("How many darts do you want to throw?");
		numdarts=Integer.parseInt(numdartString);
	/**
	* This creates the background color and the dimension of the darboard panel
	*/
      setBackground (Color.cyan);
      setPreferredSize (new Dimension(500,500));
   }

	/**
	* This paints the dartboard
	* A conditional is used to alternate the fill color of the rings from black to white
	* The small circles are used to create the diamter of the next larger circle
	* The circles are overlayed to make it look like a dartboard with rings.
	*/
   public void paintComponent (Graphics page)
   {
      super.paintComponent (page);

      int x = 0, y = 0, diameter = MAX_WIDTH;

      page.setColor (Color.white);

      for (int count = 0; count < NUM_RINGS; count++)
      {
         if (page.getColor() == Color.black) 
            page.setColor (Color.white);
         else
            page.setColor (Color.black);

         page.fillOval (x, y, diameter, diameter);

         diameter -= (2 * RING_WIDTH);
         x += RING_WIDTH;
         y += RING_WIDTH;
      }

		/**
		* This creates a red bullseye and centers it
		*/
      page.setColor (Color.red);
      page.fillOval (x, y, diameter, diameter);
		
		/**
		* This prevents users from have an non-real number of darts by making any number
		* typed in that is lower than 1 be read as 1 dart.
		*/
		if (numdarts<1)
			numdarts=1;
		
		/**
		* This will randomly draw the dart(s) unto the board
		*/
		
		randomdart = new Dart();
		
		for (int i=1;i<= numdarts;i++)
		{
		int dartscore=randomdart.score();
		totalscore+=dartscore;
		randomdart.draw(page);
		
		}
		
		/**
		* This calculates the score of the darts thrown and prints out an avg
		* by adding the total score of the darts and dividing by the numebr of darts thrown
		*/
		
		double averagescore= (double) totalscore / numdarts;
		System.out.println("You threw "+numdarts+" darts");
		System.out.println("The average points per dart is: "+averagescore);
   }
}
